!
!     CalculiX - A 3-dimensional finite element program
!              Copyright (C) 1998-2012 Guido Dhondt
!
!     This program is free software; you can redistribute it and/or
!     modify it under the terms of the GNU General Public License as
!     published by the Free Software Foundation(version 2);
!     
!
!     This program is distributed in the hope that it will be useful,
!     but WITHOUT ANY WARRANTY; without even the implied warranty of 
!     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
!     GNU General Public License for more details.
!
!     You should have received a copy of the GNU General Public License
!     along with this program; if not, write to the Free Software
!     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
!
      real*8 function volume(p1,p2,p3,p4)
!
      implicit real*8(a-h,o-z)
!
      dimension p1(3),p2(3),p3(3),p4(3)
!
      x1=p1(1)
      y1=p1(2)
      z1=p1(3)
      x2=p2(1)
      y2=p2(2)
      z2=p2(3)
      x3=p3(1)
      y3=p3(2)
      z3=p3(3)
      x4=p4(1)
      y4=p4(2)
      z4=p4(3)
!
      volume=-(((z3-z2)*y4-(y3-y2)*z4-z3*y2+y3*z2)*x1-((z3-z1)
     & *y4-(y3-y1)*z4-z3*y1+y3*z1)*x2+((z2-z1)*y4-(y2-y1)*
     & z4-z2*y1+y2*z1)*x3-((z2-z1)*y3-(y2-y1)*z3-z2*y1+y2*
     & z1)*x4)
!
      volume=dabs(volume)
!
      return
      end
