/*     CalculiX - A 3-dimensional finite element program                 */
/*              Copyright (C) 1998-2012 Guido Dhondt                          */

/*     This program is free software; you can redistribute it and/or     */
/*     modify it under the terms of the GNU General Public License as    */
/*     published by the Free Software Foundation(version 2);    */
/*                                                                       */

/*     This program is distributed in the hope that it will be useful,   */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of    */ 
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the      */
/*     GNU General Public License for more details.                      */

/*     You should have received a copy of the GNU General Public License */
/*     along with this program; if not, write to the Free Software       */
/*     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         */


/*---------------------------------------------------------------------*/
/* Strings vergleichen (bis zu welchem character sind sie gleich?)     */
/*---------------------------------------------------------------------*/

int compare (char *str1, char *str2, int length)
{
    int     i;

    i = 0;
    while ((str1[i]==str2[i]) && (i<length))
        i++;

    return i;               /* Return how far we got before a difference occurred, or the variable      */
                            /* length, whichever is the smaller                                         */
}

